/* ====================================
		ݒ
==================================== */
#include "stdafx.h"
#include "gdippManager.h"
#pragma comment(lib, "comctl32.lib")
#pragma comment(lib, "comdlg32.lib")
#pragma comment(lib, "gdi32.lib")


#define MAXFONTLISTBUF (LF_FACESIZE*32+40)

typedef struct {
	UINT Quality;
	UINT Weight;
	UINT Enhance;
	UINT MaxHeight;
	UINT UseSubPixel;
	UINT SubPixelDirection;
	UINT ForceAntialiasedQuality;
	WCHAR FontNames[MAXFONTLISTBUF];
} TIniParam;
TIniParam g_tIniParam;
BOOL g_OptApply = FALSE;

/***/
//extern HINSTANCE g_hInstance, g_hInstDLL;

LRESULT CALLBACK Opt1DlgProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK Opt2DlgProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);


#ifdef UNICODE
BOOL OpenOptionDlg(HWND hWnd)
{
	PROPSHEETPAGE psp[3];
	PROPSHEETHEADER psh;

	ZeroMemory(psp, sizeof(psp));
	int i = 0;
	psp[i].dwSize = sizeof(PROPSHEETPAGE);
	psp[i].dwFlags = PSP_USETITLE;
	/***/
	psp[i].hInstance = GetModuleHandle(NULL);//g_hInstance;
	psp[i].pszTemplate = MAKEINTRESOURCE(IDD_OPTION1);
	psp[i].pfnDlgProc = (DLGPROC)Opt1DlgProc;
	psp[i].pszTitle = L"General";
	i++;
	psp[i].dwSize = sizeof(PROPSHEETPAGE);
	psp[i].dwFlags = PSP_USETITLE;
	/***/
	psp[i].hInstance = GetModuleHandle(NULL);//g_hInstance;
	psp[i].pszTemplate = MAKEINTRESOURCE(IDD_OPTION2);
	psp[i].pfnDlgProc = (DLGPROC)Opt2DlgProc;
	psp[i].pszTitle = L"Exclude";

	ZeroMemory(&psh, sizeof(psh));

	psh.dwSize = sizeof(PROPSHEETHEADER);
	psh.dwFlags = PSH_NOAPPLYNOW | PSH_PROPSHEETPAGE;
	psh.hwndParent = hWnd;
	/***/
	psh.hInstance = GetModuleHandle(NULL);//g_hInstance;
	psh.pszCaption = L"ݒ";
	psh.nPages = sizeof(psp) / sizeof(PROPSHEETPAGE);
	psh.ppsp = (LPCPROPSHEETPAGE)&psp;

	g_OptApply = FALSE;
	PropertySheet(&psh);

	return g_OptApply;
}

#endif
void LoadSettings()
{
	WCHAR szFileName[MAX_PATH + 1] = L"";
	/***/
	// DLL̃tpX擾
	//GetModuleFileName((HMODULE)g_hInstDLL, szFileName, MAX_PATH);
	// t@Cu
	lstrcpy(szFileName, g_dllPath);
	WCHAR *sp = wcsrchr(szFileName, L'\\');
	lstrcpy(sp, INI_NAME);

	if( GetFileAttributes(szFileName) < 0 ) {
		MessageBox(NULL, L"INIt@C܂B\r\nVK쐬ɂȂ܂B",
					L"gdi++Manager", MB_ICONASTERISK|MB_TOPMOST);
	}

	// [General]ǂݍ
	const WCHAR GENERAL[] = L"General";
	// Quality
	g_tIniParam.Quality = GetPrivateProfileInt(GENERAL, L"Quality", 1, szFileName);
	if( g_tIniParam.Quality < 0 ) g_tIniParam.Quality = 0;
	else if( g_tIniParam.Quality > 3 ) g_tIniParam.Quality = 3;
	// Weight
	g_tIniParam.Weight = GetPrivateProfileInt(GENERAL, L"Weight", 0, szFileName);
	if( g_tIniParam.Weight < 0 ) g_tIniParam.Weight = 0;
	// Enhance
	g_tIniParam.Enhance = GetPrivateProfileInt(GENERAL, L"Enhance", 0, szFileName);
	if( g_tIniParam.Enhance < 0 ) g_tIniParam.Enhance = 0;
	else if( g_tIniParam.Enhance > 4 ) g_tIniParam.Enhance = 4;
	// MaxHeight
	g_tIniParam.MaxHeight = GetPrivateProfileInt(GENERAL, L"MaxHeight", 0, szFileName);
	if( g_tIniParam.MaxHeight < 0 ) g_tIniParam.MaxHeight = 0;
	// UseSubPixel
	g_tIniParam.UseSubPixel = GetPrivateProfileInt(GENERAL, L"UseSubPixel", 0, szFileName);
	g_tIniParam.UseSubPixel = (g_tIniParam.UseSubPixel == 0) ? 0 : 1;
	// SubPixelDirection
	g_tIniParam.SubPixelDirection = GetPrivateProfileInt(GENERAL, L"SubPixelDirection", 0, szFileName);
	g_tIniParam.SubPixelDirection = (g_tIniParam.SubPixelDirection == 0) ? 0 : 1;
	// ForceAntialiasedQuality
	g_tIniParam.ForceAntialiasedQuality = GetPrivateProfileInt(GENERAL, L"ForceAntialiasedQuality", 0, szFileName);
	g_tIniParam.ForceAntialiasedQuality = (g_tIniParam.ForceAntialiasedQuality == 0) ? 0 : 1;

	// [Exclude]ǂݍ
	GetPrivateProfileSection(L"Exclude", g_tIniParam.FontNames, MAXFONTLISTBUF, szFileName);
}

void WritePrivateProfileInt(LPCTSTR lpAppName, LPCTSTR lpKeyName, int Value, LPCTSTR lpFileName)
{
	WCHAR str[8];
	/***/
	//swprintf(str, L"%d", Value);
	wsprintf(str, L"%d", Value);
	WritePrivateProfileString(lpAppName, lpKeyName, str, lpFileName);
}

void SaveSettings()
{
	WCHAR szFileName[MAX_PATH + 1] = L"";
	/***/
	// DLL̃tpX擾
	//GetModuleFileName((HMODULE)g_hInstDLL, szFileName, MAX_PATH);
	// t@Cu
	lstrcpy(szFileName, g_dllPath);
	WCHAR *sp = wcsrchr(szFileName, L'\\');
	lstrcpy(sp, INI_NAME);

	// [General]ۑ
	const WCHAR GENERAL[] = L"General";
	WritePrivateProfileInt(GENERAL, L"Quality", g_tIniParam.Quality, szFileName);
	WritePrivateProfileInt(GENERAL, L"Weight", g_tIniParam.Weight, szFileName);
	WritePrivateProfileInt(GENERAL, L"Enhance", g_tIniParam.Enhance, szFileName);
	WritePrivateProfileInt(GENERAL, L"MaxHeight", g_tIniParam.MaxHeight, szFileName);
	WritePrivateProfileInt(GENERAL, L"UseSubPixel", g_tIniParam.UseSubPixel, szFileName);
	if( g_tIniParam.UseSubPixel )
		WritePrivateProfileInt(GENERAL, L"SubPixelDirection", g_tIniParam.SubPixelDirection, szFileName);
	WritePrivateProfileInt(GENERAL, L"ForceAntialiasedQuality", g_tIniParam.ForceAntialiasedQuality, szFileName);
	// [Exclude]ۑ
	const WCHAR EXCLUDE[] = L"Exclude";
	WritePrivateProfileSection(EXCLUDE, NULL, szFileName);
	WritePrivateProfileSection(EXCLUDE, g_tIniParam.FontNames, szFileName);
}

void InitGeneral(HWND hWnd)
{
	HWND hw;
	// Quality
	hw = GetDlgItem(hWnd, IDC_QUALITY);
	ComboBox_AddString(hw, L"OSW");
	ComboBox_AddString(hw, L"2{LC");
	ComboBox_AddString(hw, L"3{LC");
	ComboBox_AddString(hw, L"4{LC");
	ComboBox_SetCurSel(hw, g_tIniParam.Quality);
	// Weight
	hw = GetDlgItem(hWnd, IDC_WEIGHT_SPIN);
	SendMessage(hw, UDM_SETRANGE, 0, MAKELPARAM(4, 0));	//Ƃ肠ő4
	SendMessage(hw, UDM_SETPOS, 0, (LPARAM)g_tIniParam.Weight);
	// Enhance
	hw = GetDlgItem(hWnd, IDC_ENHANCE);
	ComboBox_AddString(hw, L"Ȃ");
	ComboBox_AddString(hw, L"");
	ComboBox_AddString(hw, L"ʂɋ");
	ComboBox_AddString(hw, L"");
	ComboBox_AddString(hw, L"");
	ComboBox_SetCurSel(hw, g_tIniParam.Enhance);
	// MaxHeight
	hw = GetDlgItem(hWnd, IDC_MAXSIZE_SPIN);
	SendMessage(hw, UDM_SETRANGE, 0, MAKELPARAM(64, 0));	//Ƃ肠ő64
	SendMessage(hw, UDM_SETPOS, 0, (LPARAM)g_tIniParam.MaxHeight);
	// UseSubPixel, SubPixelDirection
	if( g_tIniParam.UseSubPixel == 0 )
		CheckRadioButton(hWnd, IDC_SUBPIX_OFF, IDC_SUBPIX_BGR, IDC_SUBPIX_OFF);
	else
		CheckRadioButton(hWnd, IDC_SUBPIX_OFF, IDC_SUBPIX_BGR, IDC_SUBPIX_RGB+g_tIniParam.SubPixelDirection);
	// ForceAntialiasedQuality
	Button_SetCheck(GetDlgItem(hWnd, IDC_NO_CLEARTYPE), g_tIniParam.ForceAntialiasedQuality);
}

void InitExclude(HWND hWnd)
{
	HWND hList = GetDlgItem(hWnd, IDC_FONT_LIST);
	WCHAR *sp = g_tIniParam.FontNames;
	while( *sp ) {
		ListBox_AddString(hList, sp);
		sp += lstrlen(sp) + 1;
	}
}

void ApplyGeneral(HWND hWnd)
{
	// Quality
	g_tIniParam.Quality = ComboBox_GetCurSel(GetDlgItem(hWnd, IDC_QUALITY));
	if( g_tIniParam.Quality == CB_ERR ) g_tIniParam.Quality = 0;
	// Weight
	g_tIniParam.Weight = GetDlgItemInt(hWnd, IDC_WEIGHT_NUM, NULL, FALSE);
	// Enhance
	g_tIniParam.Enhance = ComboBox_GetCurSel(GetDlgItem(hWnd, IDC_ENHANCE));
	if( g_tIniParam.Enhance == CB_ERR ) g_tIniParam.Enhance = 0;
	// MaxHeight
	g_tIniParam.MaxHeight = GetDlgItemInt(hWnd, IDC_MAXSIZE_NUM, NULL, FALSE);
	// UseSubPixel,
	g_tIniParam.UseSubPixel = IsDlgButtonChecked(hWnd, IDC_SUBPIX_OFF) ? 0 : 1;
	// SubPixelDirection
	if( g_tIniParam.UseSubPixel )
		g_tIniParam.SubPixelDirection = IsDlgButtonChecked(hWnd, IDC_SUBPIX_RGB) ? 0 : 1;
	// ForceAntialiasedQuality
	g_tIniParam.ForceAntialiasedQuality = IsDlgButtonChecked(hWnd, IDC_NO_CLEARTYPE) ? 1 : 0;
}

void ApplyExclude(HWND hWnd)
{
	HWND hList = GetDlgItem(hWnd, IDC_FONT_LIST);
	WCHAR *sp = g_tIniParam.FontNames;
	int n = ListBox_GetCount(hList);
	if( n > 32 ) n = 32;
	for(int i=0; i < n ;i++) {
		ListBox_GetText(hList, i, sp);
		sp += lstrlen(sp) + 1;
	}
	*sp = 0;
}

LRESULT CALLBACK Opt1DlgProc(HWND hDlg, UINT message, WPARAM /*wParam*/, LPARAM lParam)
{
	NMHDR *nmhdr;

	switch(message) {
	case WM_INITDIALOG:
		InitGeneral(hDlg);
		return TRUE;

	case WM_NOTIFY: nmhdr = (NMHDR *)lParam;
		switch(nmhdr->code) {
		case PSN_APPLY:
			ApplyGeneral(hDlg);
			g_OptApply = TRUE;
			break;
		default:
			return FALSE;
		}
		break;
	}
	return FALSE;
}

LRESULT CALLBACK Opt2DlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	NMHDR *nmhdr;
	HWND hw;
	CHOOSEFONT cf;
	LOGFONT lf;

	switch(message) {
	case WM_INITDIALOG:
		InitExclude(hDlg);
		return TRUE;

	case WM_COMMAND:
		switch(LOWORD(wParam)) {
		case IDC_FONT_ADD:
			GetObject(GetStockObject(SYSTEM_FONT), sizeof(lf), &lf);
			ZeroMemory(&cf, sizeof(CHOOSEFONT));
			cf.lStructSize = sizeof(CHOOSEFONT);
			cf.hwndOwner = hDlg;
			cf.lpLogFont = &lf;
			cf.Flags = CF_FORCEFONTEXIST|CF_SCREENFONTS|CF_INITTOLOGFONTSTRUCT;
			cf.nFontType = SCREEN_FONTTYPE;
			if(ChooseFont(&cf) == TRUE) {
				hw = GetDlgItem(hDlg, IDC_FONT_LIST);
				if( ListBox_FindString(hw, -1, lf.lfFaceName) < 0 )
					ListBox_AddString(hw, lf.lfFaceName);
			}
			break;
		case IDC_FONT_DEL:
			hw = GetDlgItem(hDlg, IDC_FONT_LIST);
			ListBox_DeleteString(hw, ListBox_GetCurSel(hw));
			break;
		case IDC_FONT_CLEAR:
			ListBox_ResetContent(GetDlgItem(hDlg, IDC_FONT_LIST));
			break;
		}
		break;

	case WM_NOTIFY: nmhdr = (NMHDR *)lParam;
		switch(nmhdr->code) {
		case PSN_APPLY:
			ApplyExclude(hDlg);
			g_OptApply = TRUE;
			break;
		default:
			return FALSE;
		}
		break;
	}
	return FALSE;
}
